VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CAOLClipboard"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'********************************************************************************
'* Component:      CAOLClipboard
'* Author:         Craig Jasper, Jr.
'* Machine:        CJASPERJR (CP4850) -- Windows 2000 Server Edition (Service Pack 2).
'* Built Using:    Visual Basic 6.0 Enterprise Edition (Service Pack 5).
'* Modified:       1/28/2002
'********************************************************************************

' Note: I only tested this on AOL 7.0 Revision 4114.256 and the above specifications.

Option Explicit

'////////////////////////////////////////////////////////////////////////////////
' --- Error Handler Definitions ---
Private Const ERR_BASE                      As Long = 512 + vbObjectError

Private Const ERR_COMPONENT_FAILURE         As Long = ERR_BASE + 1

Private Const STR_COMPONENT_FAILURE         As String = "Component failure."
'////////////////////////////////////////////////////////////////////////////////

'////////////////////////////////////////////////////////////////////////////////
' --- API's ---
Private Declare Function CloseClipboard Lib "user32" () As Long

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" ( _
   lpvDest As Any, _
   lpvSource As Any, _
   ByVal cbCopy As Long)

Private Declare Function GetClipboardData Lib "user32" ( _
   ByVal wFormat As Long) As Long

Private Declare Function GlobalLock Lib "kernel32" ( _
   ByVal hMem As Long) As Long

Private Declare Function GlobalSize Lib "kernel32" ( _
   ByVal hMem As Long) As Long

Private Declare Function GlobalUnlock Lib "kernel32" ( _
   ByVal hMem As Long) As Long

Private Declare Function IsClipboardFormatAvailable Lib "user32" ( _
   ByVal wFormat As Long) As Long

Private Declare Function OpenClipboard Lib "user32" ( _
   ByVal hWnd As Long) As Long

Private Declare Function RegisterClipboardFormat Lib "user32" Alias "RegisterClipboardFormatA" ( _
   ByVal lpString As String) As Long
'////////////////////////////////////////////////////////////////////////////////

'********************************************************************************
' Routine:        AOLURLData
' Description:    Obtains the URL from the Windows clipboard text when you copy
'                 text from an AOL RICHCNTL that has a link on it.
' Returns:        String
' Notes:          This assumes that there is only one link in the string
'                 and will obtain only the first link in the string.
'********************************************************************************
Public Property Get AOLURLData() As String
    On Error GoTo PROC_ERR
    
    Dim lngStart        As Long
    Dim lngStop         As Long
    Dim strLink         As String
    
    strLink = AOLHTMLData
    
    If InStr(strLink, "<A HREF=") = 0 Then
        MsgBox "There is no URL data to obtain.", vbCritical
                
        Exit Property
    End If
    
    lngStart = InStr(strLink, "<A HREF=") + 9
    lngStop = InStr(lngStart, strLink, ">") - 1
    
    AOLURLData = Mid$(strLink, lngStart, lngStop - lngStart)
    
    Exit Property
PROC_ERR:
    Err.Raise ERR_COMPONENT_FAILURE, App.EXEName & ".CAOLClipboard", STR_COMPONENT_FAILURE
End Property

'********************************************************************************
' Routine:        AOLHTMLData
' Description:    Obtains the HTML that is the basis behind AOL's RICHCNTL.
' Returns:        String
'********************************************************************************
Public Property Get AOLHTMLData() As String
    On Error GoTo PROC_ERR
    
    Dim lngID As Long
        
    ' AOLMAIL, AOLMAIL2 are both used...On AOL 7.0 it
    ' is AOLMAIL2 (at the time of this writing). I haven't tested it on
    ' and other version.
    
    lngID = GetClipboardIDForCustomFormat("AOLMAIL2")
    
    If lngID <> 0 Then
        AOLHTMLData = GetClipboardDataAsString(0&, lngID)
        
        If AOLHTMLData = "" Then
            MsgBox "You need to copy text from an AOL RICHCNTL to the Windows clipboard first.", vbCritical
            
            Exit Property
        End If
        
    End If
               
    Exit Property
PROC_ERR:
    Err.Raise ERR_COMPONENT_FAILURE, App.EXEName & ".CAOLClipboard", STR_COMPONENT_FAILURE
End Property

'********************************************************************************
' Routine:        GetClipboardIDForCustomFormat
' Description:    Obtains the ID for the clipboard format.
' Parameters:     strFormatName (String): Format name to get ID for.
' Returns:        Long
' Notes:          This function was written by Steve McMahon from VBAccelerator and
'                 has been modified by myself (to my preferences).
'********************************************************************************
Private Function GetClipboardIDForCustomFormat(ByVal strFormatName As String) As Long
    On Error GoTo PROC_ERR
    
    Dim lngFormat As Long
    
    lngFormat = RegisterClipboardFormat(strFormatName & vbNullChar)
    
    If lngFormat > &HC000& Then
        GetClipboardIDForCustomFormat = lngFormat
    End If
    
    Exit Function
PROC_ERR:
    Err.Raise ERR_COMPONENT_FAILURE, App.EXEName & ".CAOLClipboard", STR_COMPONENT_FAILURE
End Function

'********************************************************************************
' Routine:        GetClipboardDataAsString
' Returns:        String
' Notes:          This function was written by Steve McMahon from VBAccelerator and
'                 the only modification I've done to it is is added
'                 an error handler. This is why you don't see my standard
'                 naming conventions on this routine.
'********************************************************************************
Private Function GetClipboardDataAsString(ByVal hWndOwner As Long, ByVal lFormatID As Long) As String
    On Error GoTo PROC_ERR
    
    Dim bData() As Byte
    Dim hMem As Long
    Dim lSize As Long
    Dim lPtr As Long
    
    ' Open the clipboard for access:
    If (OpenClipboard(hWndOwner)) Then
        ' Check if this data format is available:
        If (IsClipboardFormatAvailable(lFormatID) <> 0) Then
            ' Get the memory handle to the data:
            hMem = GetClipboardData(lFormatID)
            If (hMem <> 0) Then
                ' Get the size of this memory block:
                lSize = GlobalSize(hMem)
                If (lSize > 0) Then
                    ' Get a pointer to the memory:
                    lPtr = GlobalLock(hMem)
                    If (lPtr <> 0) Then
                        ' Resize the byte array to hold the data:
                        ReDim bData(0 To lSize - 1) As Byte
                        ' Copy from the pointer into the array:
                        CopyMemory bData(0), ByVal lPtr, lSize
                        ' Unlock the memory block:
                        GlobalUnlock hMem
                        
                        ' Now return the data as a string:
                        GetClipboardDataAsString = StrConv(bData, vbUnicode)

                    End If
                End If
            End If
        End If
        
        CloseClipboard
    End If
    
    Exit Function
PROC_ERR:
    Err.Raise ERR_COMPONENT_FAILURE, App.EXEName & ".CAOLClipboard", STR_COMPONENT_FAILURE
    
    Resume Next
End Function
